package icao

import (
	"time"

	"gorm.io/gorm"

	"wucher/internal/domain/federal_state"
	"wucher/internal/domain/land"
	"wucher/internal/shared/pkg/uuidv7"
)

type ICAO struct {
	ID             []byte `gorm:"type:binary(16);primaryKey;column:id"`
	FederalStateID []byte `gorm:"type:binary(16);index;column:federal_state_id"`
	LandID         []byte `gorm:"type:binary(16);index;column:land_id"`
	ICAOCode       string `gorm:"type:varchar(16);not null;column:icao_code"`
	Name           string `gorm:"type:varchar(150);not null;column:name"`
	SortKey        *int   `gorm:"column:sortkey"`
	Address        string `gorm:"type:varchar(256);column:address"`
	LandlineNumber string `gorm:"type:varchar(20);column:landline_number"`
	MobileNumber   string `gorm:"type:varchar(20);column:mobile_number"`
	Email          string `gorm:"type:varchar(128);column:email"`
	Note           string `gorm:"type:text;column:note"`
	IsActive       bool   `gorm:"type:tinyint(1);index;not null;default:1;column:is_active"`

	FederalState *federal_state.FederalState `gorm:"foreignKey:FederalStateID;references:ID"`
	Land         *land.Land                  `gorm:"foreignKey:LandID;references:ID"`

	CreatedAt time.Time  `gorm:"column:created_at"`
	CreatedBy []byte     `gorm:"type:binary(16);column:created_by"`
	UpdatedAt time.Time  `gorm:"column:updated_at"`
	UpdatedBy []byte     `gorm:"type:binary(16);column:updated_by"`
	DeletedAt *time.Time `gorm:"column:deleted_at"`
	DeletedBy []byte     `gorm:"type:binary(16);column:deleted_by"`
}

func (ICAO) TableName() string { return "icaos" }

func (i *ICAO) BeforeCreate(tx *gorm.DB) error {
	if len(i.ID) == 0 {
		i.ID = uuidv7.MustBytes()
	}
	return nil
}
